from torch_geometric.datasets import Planetoid
from torch_geometric.utils import add_remaining_self_loops, to_undirected

import os.path as osp
import sys
sys.path.extend([
    osp.dirname(osp.dirname(osp.abspath(__file__))),
])

from utils.partition import partition_save

if __name__ == "__main__":
    data = Planetoid("/mnt/nfs/hwj/pyg_datasets/Planetoid/Cora", "Cora")[0]
    if data.is_directed():
        data.edge_index, _ = to_undirected(data.edge_index)
    data.edge_index, _ = add_remaining_self_loops(data.edge_index)
    
    print(f"num_nodes: {data.num_nodes}")
    print(f"num_edges: {data.num_edges}")
    print(f"num_features: {data.num_features}")
    
    num_parts_list = [1, 2, 3, 5, 7, 9, 11]
    algos = ["metis", "dbh"]
    
    root = osp.splitext(osp.abspath(__file__))[0]
    print(f"root: {root}")
    for num_parts in num_parts_list:
        for algo in algos:
            print(f"======== {num_parts} + {algo} ========")
            partition_save(root, data, num_parts, algo)
    
    # for num_parts in num_parts_list:
    #     for algo in algos:
    #         print(f"======== {num_parts} + {algo} ========")
    #         stat = PartitionStatistic(num_parts, algo)(base_dir)
            
    #         node_balance = min(stat["node_count"]) / max(stat["node_count"])
    #         edge_balance = min(stat["edge_count"]) / max(stat["edge_count"])
    #         local_node_percent = max(stat["local_node_percent"])
    #         global_node_percent = max(stat["global_node_percent"])
    #         print(f"node balance: {node_balance:.2f}")
    #         print(f"edge balance: {edge_balance:.2f}")
    #         print(f"local node percent: {local_node_percent:.2f}")
    #         print(f"global node percent: {global_node_percent:.2f}")